Package org.apache.tapestry5.services

## Class ComponentLibraryInfo

- java.lang.Object
- - org.apache.tapestry5.services.ComponentLibraryInfo

- All Implemented Interfaces:
    `java.io.Serializable`

      public final class ComponentLibraryInfo
      extends java.lang.Object
      implements java.io.Serializable

  Class that encapsulates information about a component library, going beyond what a library mapping provides.
  Since:
    5.4
  See Also:
    `LibraryMapping`, `ComponentLibraryInfo.SourceUrlResolver`, Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `ComponentLibraryInfo.DefaultSourceUrlResolver` | Default `ComponentLibraryInfo.SourceUrlResolver` implementation.
    `static interface` | `ComponentLibraryInfo.SourceUrlResolver` | Interface that provides the source URL for a given `ComponentLibraryInfo`.

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ComponentLibraryInfo()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.String` | `getArtifactId()` | Returns the component library's group id for dependency management tools like Maven and Gradle.
    `java.lang.String` | `getDependencyManagementInfoUrl()` | Returns an URL decribing the dependency management information for this component library.
    `java.lang.String` | `getDescription()` | Returns a description of the component library.
    `java.lang.String` | `getDocumentationUrl()` | Returns the URL of the component library's documentation.
    `java.lang.String` | `getGroupId()` | Returns the component library's group id for dependency management tools like Maven and Gradle.
    `java.lang.String` | `getHomepageUrl()` | Returns the URL of the homepage of the component library.
    `java.lang.String` | `getIssueTrackerUrl()` | Returns the URL of the component's library issue tracker.
    `java.lang.String` | `getJavadocUrl()` | Returns the URL of the component library's JavaDoc URL.
    `java.lang.String` | `getJavadocUrl​(java.lang.String className)` | Returns the JavaDoc URL for a given class or `null` if the root JavaDoc URL was not provided.
    `java.lang.String` | `getName()` | Returns the actual name of the component library (not the identifier).
    `java.lang.String` | `getSourceBrowseUrl()` | Returns the URL where the component library's source can be browsed.
    `java.lang.String` | `getSourceRootUrl()` | Returns the URL where the root folder of component library's source can be found.
    `java.lang.String` | `getSourceUrl​(java.lang.String className)` | Returns the URL where the source of this class can be found or `null` if not available.
    `java.util.List<java.lang.String>` | `getTags()` | Returns the tags associated which describe this component library.
    `java.lang.String` | `getTapestryVersion()` | Returns the Tapestry version used by this component library.
    `java.lang.String` | `getVersion()` | Returns the component library version.
    `boolean` | `isDependencyManagementInfoPresent()` | Tells whether full dependency management info (group id, artifact id and version) are present.
    `boolean` | `isPart​(java.lang.String logicalName)` | Given a logical name, tells whether a given component, page or mixin is part of this component library.
    `void` | `setArtifactId​(java.lang.String artifactId)` |
    `void` | `setDescription​(java.lang.String description)` |
    `void` | `setDocumentationUrl​(java.lang.String documentationUrl)` |
    `void` | `setGroupId​(java.lang.String groupId)` |
    `void` | `setHomepageUrl​(java.lang.String homepageUrl)` |
    `void` | `setIssueTrackerUrl​(java.lang.String issueTrackingUrl)` |
    `void` | `setJavadocUrl​(java.lang.String javadocUrl)` |
    `void` | `setLibraryMapping​(LibraryMapping libraryMapping)` |
    `void` | `setName​(java.lang.String name)` |
    `void` | `setSourceBrowseUrl​(java.lang.String sourceBrowseUrl)` |
    `void` | `setSourceRootUrl​(java.lang.String sourceRootUrl)` |
    `void` | `setSourceUrlResolver​(ComponentLibraryInfo.SourceUrlResolver sourceUrlResolver)` |
    `void` | `setTags​(java.util.List<java.lang.String> tags)` |
    `void` | `setTapestryVersion​(java.lang.String tapestryVersion)` |
    `void` | `setVersion​(java.lang.String version)` |
    `java.lang.String` | `toString()` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ComponentLibraryInfo

          public ComponentLibraryInfo()

  - ### Method Detail

    - #### getName

          public java.lang.String getName()

      Returns the actual name of the component library (not the identifier). For example, "Tapestry 5 Core Library".

    - #### getDescription

          public java.lang.String getDescription()

      Returns a description of the component library. For example, "The set of components, pages and mixins provided by Tapestry out-of-the-box.".

    - #### getHomepageUrl

          public java.lang.String getHomepageUrl()

      Returns the URL of the homepage of the component library. For example, "http://tapestry.apache.org".

    - #### getDocumentationUrl

          public java.lang.String getDocumentationUrl()

      Returns the URL of the component library's documentation. For example, "http://tapestry.apache.org/documentation.html".

    - #### getSourceBrowseUrl

          public java.lang.String getSourceBrowseUrl()

      Returns the URL where the component library's source can be browsed. For example, "https://git-wip-us.apache.org/repos/asf?p=tapestry-5.git;a=summary".

    - #### getSourceRootUrl

          public java.lang.String getSourceRootUrl()

      Returns the URL where the root folder of component library's source can be found. For example, "https://git-wip-us.apache.org/repos/asf?p=tapestry-5.git;a=tree;f=tapestry-core/src/main/java/".

    - #### getIssueTrackerUrl

          public java.lang.String getIssueTrackerUrl()

      Returns the URL of the component's library issue tracker. For example, "https://issues.apache.org/jira/browse/TAP5".

    - #### getJavadocUrl

          public java.lang.String getJavadocUrl()

      Returns the URL of the component library's JavaDoc URL. For example, "http://tapestry.apache.org/current/apidocs/"

    - #### getGroupId

          public java.lang.String getGroupId()

      Returns the component library's group id for dependency management tools like Maven and Gradle. For example, "org.apache.tapestry".
      See Also:
        `artifactId`, `version`

    - #### getArtifactId

          public java.lang.String getArtifactId()

      Returns the component library's group id for dependency management tools like Maven and Gradle. For example, "tapestry-core".
      See Also:
        `groupId`, `version`

    - #### getVersion

          public java.lang.String getVersion()

      Returns the component library version. For example, "5.4.0".
      See Also:
        `artifactId`, `groupId`

    - #### getTapestryVersion

          public java.lang.String getTapestryVersion()

      Returns the Tapestry version used by this component library. For example, "5.4.0".

    - #### getTags

          public java.util.List<java.lang.String> getTags()

      Returns the tags associated which describe this component library. Use just lowercase letters, numbers and dashes.

    - #### getDependencyManagementInfoUrl

          public java.lang.String getDependencyManagementInfoUrl()

      Returns an URL decribing the dependency management information for this component library.

    - #### setName

          public void setName​(java.lang.String name)

    - #### setDescription

          public void setDescription​(java.lang.String description)

    - #### setHomepageUrl

          public void setHomepageUrl​(java.lang.String homepageUrl)

    - #### setDocumentationUrl

          public void setDocumentationUrl​(java.lang.String documentationUrl)

    - #### setSourceBrowseUrl

          public void setSourceBrowseUrl​(java.lang.String sourceBrowseUrl)

    - #### setSourceRootUrl

          public void setSourceRootUrl​(java.lang.String sourceRootUrl)

    - #### setJavadocUrl

          public void setJavadocUrl​(java.lang.String javadocUrl)

    - #### setVersion

          public void setVersion​(java.lang.String version)

    - #### setTapestryVersion

          public void setTapestryVersion​(java.lang.String tapestryVersion)

    - #### setGroupId

          public void setGroupId​(java.lang.String groupId)

    - #### setArtifactId

          public void setArtifactId​(java.lang.String artifactId)

    - #### setIssueTrackerUrl

          public void setIssueTrackerUrl​(java.lang.String issueTrackingUrl)

    - #### setTags

          public void setTags​(java.util.List<java.lang.String> tags)

    - #### setLibraryMapping

          public void setLibraryMapping​(LibraryMapping libraryMapping)

    - #### setSourceUrlResolver

          public void setSourceUrlResolver​(ComponentLibraryInfo.SourceUrlResolver sourceUrlResolver)

    - #### isDependencyManagementInfoPresent

          public boolean isDependencyManagementInfoPresent()

      Tells whether full dependency management info (group id, artifact id and version) are present.

    - #### isPart

          public boolean isPart​(java.lang.String logicalName)

      Given a logical name, tells whether a given component, page or mixin is part of this component library.

    - #### getJavadocUrl

          public java.lang.String getJavadocUrl​(java.lang.String className)

      Returns the JavaDoc URL for a given class or `null` if the root JavaDoc URL was not provided.
      Parameters:
        `className` - the fully qualified class name.

    - #### getSourceUrl

          public java.lang.String getSourceUrl​(java.lang.String className)

      Returns the URL where the source of this class can be found or `null` if not available. This implementation delegates to `ComponentLibraryInfo.SourceUrlResolver` if set.
      Parameters:
        `className` - the fully qualified class name.

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`